<?

class csv {

var $delimiter;
var $enclosure;

var $csv_str;
var $csv_arr;

var $got_data;

var $init;
var $init_type;

var $line;

var $max_line = 1024;

function csv($delimiter = ",", $enclosure = "\"") {
$this->setDelimiter($delimiter);
$this->setEnclosure($enclosure);
$this->init_type = "";
$this->_no_data();
}

//           /                    
 function setDelimiter($value) {
$this->delimiter = $value;
}

function setEnclosure($value) {
$this->enclosure = $value;
}

function setCSVData($value) {
$this->_new_data();
$this->csv_str = $value;
}

function setCSV($value) {
$this->csv_arr = $value;
}

function getDelimiter() {
return $this->delimiter;
}

function getEnclosure() {
return $this->enclosure;
}

function getCSVData() {
return $this->csv_str;
}

function getCSV() {
return $this->csv_arr;
}

//                        
 function init_from_data($value) {
$this->init_type = "data";
$this->setCSVData($value);
}

function init_from_fp($value) {
$this->init_type = "fp";
$this->init = $value;
$this->_no_data();
}

function init_from_file($value) {
if (file_exists($value)) {
$this->init_type = "file";
$this->init = fopen($value,"r");
$this->_no_data();
return 0;
} else {
return 1;
}
}

//                      
 function build_csv($newline = "\r\n") {
$this->csv_str = "";

foreach ($this->csv_arr as $line) {
foreach ($line as $key=>$value) {
if ($key > 0) $this->csv_str .= $this->delimiter;
if ($value && !is_numeric($value)) {
$this->csv_str .= $this->enclosure.$value.$this->enclosure;
} else {
$this->csv_str .= $value;
}
}
$this->csv_str .= $newline;
}
}

function parse_csv($skip_lines = 0) {
$this->csv_arr = array();
$cline = 0;

while ($line = $this->_get_csv_line()) {
if ($cline >= $skip_lines) $this->csv_arr[] = $line;
$cline++;
}
}

//                             
 function _get_csv_line() {
$rs = false;

if ($this->_has_data()) {
//       
 
} else if ($this->init_type == "fp" || $this->init_type == "file") {
$rs = fgetcsv($this->init,$this->max_line,$this->delimiter);
}

return $rs;
}

function _new_data() {
$this->got_data = true;
$this->line = 0;
}

function _no_data() {
$this->got_data = false;
}

function _has_data() {
return $this->got_data;
}
}

?>
