<?

class WikiController {

var $errorMsg;
var $redo;

function WikiController() {
$this->errorMsg = "";
$this->redo = array();
}

function run() {
return false;
}

function getErrorMsg() {
return $this->errorMsg;
}

function getRedirectVars() {
return $this->redo;
}

function setupRedirect() {
if ($this->errorMsg) {
return false;
}
foreach ($this->redo as $var=>$val) {
global $$var;
$$var = $val;
}
return true;
}

function setError($text) {
$this->errorMsg = $text;
}

function setRedirectVar($var, $val) {
$this->redo[$var] = $val;
}

function setRealRedirect($id, $folder) {
global $DO, $FEATURE;

$this->setRedirectVar("REDO", 14013);
if ($FEATURE['wikiedit']) {
$this->setRedirectVar("real", "edit");
} else {
$this->setRedirectVar("real", "view");
}
$this->setRedirectVar("realid", $id);
$this->setRedirectVar("FOLDER_ID", $folder);
$this->setRedirectVar("realback", array("REDO"=>$DO, "close"=>1));
}
}

class WikiNewPage extends WikiController {

var $folder;
var $template;
var $name;
var $contentgroup_id;

function WikiNewPage($folder, $template = "", $name = "", $lang = false) {
parent::WikiController();
$this->folder = (int)$folder;
$this->template = (int)$template;
$this->name = $name;
//                                     
 $this->contentgroup_id = ($lang) ? $this->getContentgroupIdByLang($lang) : 0;
}

/**
  *                                         
  *                              
  *                                            
  */
function getContentgroupIdByLang($lang) {
$sql = 'SELECT contentgroup.id
			FROM contentgroup, language
			WHERE contentgroup.id = language.id
				AND language.active = 1
				AND contentgroup.code = "' . strtolower(sqlslashes($lang)) . '"';
$rs = query($sql);//            
 if (is_array($rs["arr"][0]) && count($rs["arr"][0]) == 0) return 0;
return $rs["arr"][0][0];
}

function run() {

global $USER_ID, $T_FOLDER;

node_include("get_info");
node_include("i18n");
node_include("perm");

$info = get_folderinfo($this->folder);

if (!$info["id"]) {
$this->setError(i18n("The folder cannot be found"));
return false;
}

if (!perm($USER_ID, $T_FOLDER, $this->folder, 12)) {
$this->setError(i18n("You dont have permissions to create pages in this folder"));
return false;
}

if (!$this->template) {
$sql = "SELECT template_id FROM template_folder WHERE folder_id = ".sqlf_tl_num($this->folder);
$rs = query($sql);//            
 if ($rs["num"] == 0) {
$this->setError(i18n("Could not find a template in this folder"));
return false;
}
//                                  
 $this->template = $rs["arr"][0]["template_id"];
} else {
$tinf = get_templateinfo($this->template);
if (!$tinf["id"]) {
$this->setError(i18n("Could not find template"));
return false;
}
}

node_include("page_cmd");

//                                                                   
 if ($this->contentgroup_id) {
$id = cmd_page_create($this->name, "", 1, "", $this->template, $this->folder, $this->contentgroup_id, cmd_page_createcs());
} else {
$id = cmd_page_create($this->name, "", 1, "", $this->template, $this->folder);
}

$this->setRealRedirect($id, $this->folder);

return true;
}

}

class WikiEditPage extends WikiController {

var $id;

function WikiEditPage($id) {
parent::WikiController();
$this->id = (int)$id;
}

function run() {

global $USER_ID, $T_FOLDER;

node_include("get_info");
node_include("lock");
node_include("i18n");
node_include("perm");

$info = get_pageinfo($this->id);

if (!$info) {
$this->setError(i18n("The page cannot be found"));
return false;
}

if (is_locked($this->id, "page")) {
$this->setError(i18n("The page is currently locked by another user"));
return false;
}

if (!perm($USER_ID, $T_FOLDER, $info["folder_id"], 13)) {
$this->setError(i18n("You dont have permissions to edit this page"));
return false;
}

$this->setRealRedirect($this->id, $info["folder_id"]);

return true;
}

}

?>
