<?

class DataHelper
{
var $xml;
var $pos = 0;
var $beginTags, $endTags;

function DataHelper( $xml, $beginTags, $endTags )
{
$this->xml = $xml;
$this->beginTags = $beginTags;
$this->endTags = $endTags;
}

function findFirst( $str, $tags, $startPos )
{
$ret = false;
$retTag = false;
foreach ( $tags as $key=>$tag )
{
$pos = strpos( $str, $tag, $startPos );
if ( $pos !== false )
{
if ( $ret === false || $pos < $ret )
{
$ret = $pos;
$retTag = $key;
}
}
}
return array( "pos"=>$ret, "tagid"=>$retTag );
}

function nextData()
{
$beginArr = $this->findFirst( $this->xml, $this->beginTags, $this->pos );
$begin = $beginArr["pos"];
if ( $begin === false ) return false;
$tagId = $beginArr["tagid"];
$end = strpos( $this->xml, $this->endTags[$tagId], $this->pos );
if ( $end != false )
{
$begin += strlen( $this->beginTags[$tagId] );
$this->pos = $end + strlen( $this->endTags[$tagId]);
$length = $end - $begin;
return substr( $this->xml, $begin, $length );
}
else
return false;
}
}

class RowHelper
{
/**                                */
var $rowDataHelper;
var $cellKeys;

function RowHelper( $xml, $cellKeys )
{
$this->rowDataHelper = new DataHelper($xml, array("<Row>"), array("</Row>") );
$this->cellKeys = $cellKeys;
}

function nextRow()
{
$cells = $this->rowDataHelper->nextData();
if ( $cells === false ) return false;
$cellHelper = new DataHelper($cells, array(
"<Cell><Data ss:Type=\"Number\">",
"<Cell><Data ss:Type=\"String\">" 
), 
array(
"</Data></Cell>",
"</Data></Cell>"
) );
$i = 0;
$ret = array();
while ( ($cell=$cellHelper->nextData()) !== false )
{
$ret[$this->cellKeys[$i++]] = $cell;
}
return $ret;
}
}


function import_dic( &$form, $param )
{

/*                      */
//                                      
 /*                           */
//                                   
 /*                       */
//                           

echo "<p>Weil der Upload noch nicht funktioniert bitte im Source von system/core/dic_import.php Zeile 102-103 Einkommenieren und anpassen.</p>";
//                                                       
 /* /
               /    /     /         
                              
                                         
  /* */

$idList = array();
foreach ( $param as $cId => $p )
{
unset( $c );
$c =& $form->getComponent($cId);
if ( $c->getText() )
{
$idList[$c->getText()-1] = $p["name"];
}
}
ksort( $idList );
$rowHelper = new RowHelper($xml, array_merge( array("id"), $idList ) );
query('BEGIN');//            
 while ( ($row=$rowHelper->nextRow()) !== false )
{
//                                     
 $row['Deutsch'] = utf8_decode($row['Deutsch']);
$row['English'] = utf8_decode($row['English']);
$rs = query(//            
sprintf("SELECT value FROM dic WHERE output_id = %s AND language_id = 1",
sqlf_tl_num($row['id'])
));
$sql = "";
if ($rs['arr'][0]['value'] != $row['Deutsch']) {
//                                         
 $j++;
echo 'Unterschiede bei id <b>'.$row['id'].'</b><br><b>DB Deutsch</b><br>'.$rs['arr'][0]['value'].'<br><b>file Deutsch</b><br>'.$row['Deutsch'].'<br><b>file English</b><br>'.$row['English'].'<hr>';
} else {
//                  
 $i++;
$str = str_replace('&quot;', '"', $row['English']);
$str = str_replace('&amp;', '&', $str);
$str = str_replace('&lt;', '<', $str);
$str = str_replace('&gt;', '>', $str);
$str = str_replace('&#10;', ' ', $str);
$sql = sprintf("UPDATE dic SET value = '%s' WHERE output_id = %s AND language_id = 2",
sqlslashes($str),
sqlf_tl_num($row['id'])
);
}
//                                                       
 /* /
                          
               //            
   /* */
}
echo "<P>$i ok. $j different!</P>";
if ( !$query_executed ) echo '<h1>Achtung query wurde nicht ausgefhrt</h1>Zeile 148 einkommentieren.<br>';
query('COMMIT');//            
 }

GUIFactory::setMainGUI("main");

$form = new HtmlForm3("dicimport");
if ( $form->isNew() )
{
node_class( "filecomponent" );
node_class( "textcomponent" );
$form->setHeader(i18n("Dictionary Import"));
$form->addComponent("file", new FileComponent("XML-File"));
$sql = "SELECT * FROM language";
$rs = query( $sql );//            
 $i=0;
$options = array();
foreach ( $rs["arr"] as $row )
{
$options["ass".$i] = array( "lang_id"=>$row["id"], "name"=>$row["name"] );
$form->addComponent("ass".$i, new TextComponent($row["name"], true));
$i++;
}
$form->addButton( "import", new Button( i18n("Import") ), new SimpleFormAction( "import_dic", $options ), true );
}
?>
