<?

global $BROWSCAP_INIFILE, $TOPLEVEL_INIFILE, $INI_FILES;
$BROWSCAP_INIFILE = $NODEPATH."/lib/ini/browscap.ini";
$TOPLEVEL_INIFILE = $NODEPATH."/lib/ini/toplevel.ini";
$INI_FILES = Array();

//                                           
//                                                                                         
//                                                                                               
//                                              
//                                                  
//                                                         
function read_ini_section($file, $section, $ignorecase=true, $wildcards=true, $parent="", $fileclose=false,$visited="") {

global $MATCH, $INI_FILES;

if (!$INI_FILES[$file]) {
if (!file_exists($file)) return false;
$f = fopen($file, "r");
$INI_FILES[$file] = $f;
} else {
$f = $INI_FILES[$file];
fseek($f,0,SEEK_SET);
}

$val = false;

$ereg = ($ignorecase)?"eregi":"ereg";

$match = "[".$section."]";

while (!feof($f)) {
$s = fgets($f,256);
if (!ereg("^ *(\[.+\])",$s,$r)) continue;
$s = $r[1];
$s = str_replace("\\","\\\\",$s);
$s = str_replace("(","\\(",$s);
$s = str_replace(")","\\)",$s);
$s = str_replace("[","\\[",$s);
$s = str_replace("]","\\]",$s);
$s = str_replace(".","\\.",$s);
$s = str_replace("_","\\_",$s);
$s = str_replace("*",($wildcards)?"(.*)":"\*",$s);
if ($ereg($s,$match,$regs)) {
$val = array();
while (!feof($f)) {
$s = fgets($f,1024);
$s = str_replace("\n","",$s);
$s = str_replace("\r","",$s);
if (!$s || ereg("^ *;",$s)) continue;
if (ereg("^ *\[",$s)) break;
if (ereg("^ *([^= ]+) *= *([^ ].*)[ \n\r]*$",$s,$r)) $val[strtolower($r[1])] = $r[2];
}
if ($fileclose) {
fclose($f);
$INI_FILES[$file] = false;
}
if (!is_array($visited)) {
$MATCH = $regs;
}
if ($parent && $val[$parent]) {
if (!$visited) $visited = array();
$visited[$section] = true;
if (!$visited[$val[$parent]]) {
$p = read_ini_section($file,$val[$parent],$ignorecase,$wildcards,$parent,$fileclose,$visited);
if (is_array($p)) $val = array_merge($p, $val);
}
}
return $val;
}
}
if ($fileclose) {
fclose($f);
$INI_FILES[$file] = false;
}
return $val;
}

?>
