<?php

class SQLDeleteAction extends ItemListAction
{
var $d_sql;
var $d_commandName;
var $d_commandDescr;
var $d_iconTag;
var $d_dbHandle;


var $d_logComment;
var $d_tType;
var $d_id2;

/**
  *                                   
  * 
  *                                                                                
  *                                                                                    
  *                                                              
  *                                                   
  *                                                    
  *                                                                             
  *                                                                               
  *                                                                 
  *                     
  *                          
  *                       
  *         
  **/
function SQLDeleteAction( $iconTag, $t_type, $desc, $table, $idColumn, $id2=0, $logComment="deleteAction", $where=null, $dbHandle=null, $command="del" )
{
$this->d_iconTag = $iconTag;
$this->d_commandDescr = $desc;
$this->d_commandName = $command;		
$this->d_dbHandle = $dbHandle;
$this->d_logComment = $logComment;
$this->d_id2 = $id2;
$this->d_tType = $t_type;

$this->d_sql = "DELETE FROM ".sqlf_table($table)." ";
if ( $where )
{
$this->d_sql .= "WHERE $where AND ".sqlf_field($idColumn)." IN (";	
}
else
$this->d_sql .= "WHERE ".sqlf_field($idColumn)." IN (";
}

/**
  *                          
  * 
  *                                                                   
  **/
function getCommandName() 
{
return $this->d_commandName;
}
/**
  *                                 
  * 
  *                                                                                     
  *                
  * 
  *                                    
  **/
function getDescription ()
{
return $this->d_commandDescr;
}

function getIconTag()	
{	
return $this->d_iconTag;
}

/**
  *                                
  * 
  *                                  
  * 
  *                                                                
  *                                                                              
  **/
function performAction( $idList ) 
{
global $W_DEL;

$sql = $this->d_sql . implode(", ", sqlf_tl_num_array($idList)) . ")";
query( $sql, $this->d_dbHandle );//            
 if ( $this->d_tType > 0 )
{
foreach ( $idList as $val )
{
logcmd( $W_DEL, $this->d_tType, $val, $this->d_id2, $this->d_logComment );
}
}
//  //                                 //                  
 }

}

?>
