<?

/**********************************
 * 
 *                                                                      
 *
 *                                                                                                        
 *
 *                                                             
 *                                                /        
 *                                                       
 *
 *                                                                                                
 *                               
 *                                                                                                                
 *                                                                    
 *
 *                                                                                              
 *                                         
 *                           
 *                                                                 
 *                                                                                                            /                        
 *
 *                                                                              
 *                                           
 *
 *                                                                                       
 *
 *                                                             
 *                                                                                           
 *
 *                                                               
 *                                                                                       
 *
 *                                                                           
 *                                       
 *                                                                                                                 
 *  
 *                                                                           
 *                                                                    
 * 
 *                                                                                        
 *                                                                                             
 *                                                                         
 *                                                                               
 *
 *                                         
 *
 ********************************/

global $DTYPE_CACHE, $MDTYPE_CACHE, $INSTANT_CACHE;

$DTYPE_CACHE = array();
$MDTYPE_CACHE = array();
$INSTANT_CACHE = array();

//                                                            
function tree_get_name($ntype, $nid, $t_type = "", $rowval = "") {
global $T_TYPE;

if (!is_array($t_type)) $t_type = $T_TYPE;

if ($t_type[$ntype]["self"] && is_numeric($nid)) {
$sql = $t_type[$ntype]["self"].sqlf_tl_num($nid);
$rs = query($sql,1);//            
 
$name = $rs["arr"][0]["name"];
} else if ($t_type[$ntype]["self_fkt"]) {
$itype = tree_get_typeinstance($ntype, $nid, $t_type, $rowval);
$name = $itype["self_fkt"];
} else {
$name = $t_type[$ntype]["name"];
}

return $name;
}

//                                        
function tree_get_typeinstance($ntype, $nid, $t_type = "", $rowval = "", $field = "", $skipfields="") {
global $T_PTREE, $T_TYPE, $PERMSQL, $DTYPE_CACHE, $MDTYPE_CACHE, $PATH, $DEBUG, $INSTANT_CACHE, $USER_ID, $STAG_PREFIX, $SID;

//                                                
 //                                           
 if (!is_array($t_type)) $t_type = $T_TYPE;

//                                                          /              
 //                                  
 //                                                 
/*                  
                         */
$ntype = (int) $ntype;

//                            
 $itype = $t_type[$ntype];

$itype_key = md5(serialize($itype).":".serialize($rowval));
if (isset($INSTANT_CACHE["instance"][$ntype][$nid][$itype_key])) {
return $INSTANT_CACHE["instance"][$ntype][$nid][$itype_key];
}

//                                               
 if (is_array($rowval)) {
while (list($key,$val) = each($rowval)) {
if (is_string($key)) {
$$key = $val;
if ($DEBUG["echo"] && $DEBUG["tree"]) echo "Var: $key, Val: $val<br>\n";
}
}
}

//                               
 if (!$DTYPE_CACHE || !$MDTYPE_CACHE) {
$sql = "SELECT id, mother_id, mother_type, link, name, allowlink, folderopen, folderclosed, prepend, append, linktarget, linkext, sqlstmt, fkt, bind_id, bind_type FROM ptree LEFT JOIN perm ON perm.o_id = ptree.id AND perm.o_type = ".sqlf_tl_num($T_PTREE)." AND ($PERMSQL) WHERE (perm.o_id IS NULL OR perm.perm LIKE '1%' OR ".sqlf_tl_num($USER_ID)." = 1) GROUP BY ptree.id";
$rs = query($sql);//            

if ($rs["num"] == 0) {
$DTYPE_CACHE = -1;
$MDTYPE_CACHE = -1;
} else {
while (list($key,$val) = each($rs["arr"])) {
$val["sql"] = $val["sqlstmt"];
$DTYPE_CACHE[$val["id"]] = $val;
$MDTYPE_CACHE[$val["mother_id"]][$val["mother_type"]][] = $val;
}
}
}

//                         
 if ($ntype == $T_PTREE) {
$type = $DTYPE_CACHE[$nid];

if ($type["folderopen"]) $type["folderopen"] = "$STAG_PREFIX?do=11&url=".$type["folderopen"];
if ($type["folderclosed"]) $type["folderclosed"] = "$STAG_PREFIX?do=11&url=".$type["folderclosed"];

$subst = array("link","allowlink","folderopen","folderclosed","prepend","append","linktarget","linkext");

while (list($key,$val) = each($subst)) {
if (!isset($itype[$val])) $itype[$val] = $type[$val];
}
}

//              
 $eval = array("link","linktarget","linkext","sql","sqlleaf","prepend","append","chksql", "fkt", "folderopen", "folderclosed", "parent", "parentfkt");
$evalfkt = array("allowlink","allowchk", "context", "self_fkt", "outfkt");

if ($field && !is_array($field)) {
$field = array($field);
}

while (list($key,$val) = each($eval)) {
if (is_array($field) && !in_array($val,$field)) continue;
if (is_array($skipfields) && in_array($val,$skipfields)) continue;
if ($tmp = $itype[$val]) {
eval("\$tmp = \"$tmp\";");
$itype[$val] = $tmp;
}
}
while (list($key,$val) = each($evalfkt)) {
if (is_array($field) && !in_array($val,$field)) continue;
if (is_array($skipfields) && in_array($val,$skipfields)) continue;
if ($tmp = $itype[$val]) {
eval("\$tmp = $tmp;");
$itype[$val] = $tmp;
}
}

if ( !is_array($field) && !is_array($skipfields) ) {
$INSTANT_CACHE["instance"][$ntype][$nid][$itype_key] = $itype;
}

return $itype;
}

//                                                                                                    
//                                                                                 /                                                
//                                                                       
//                                                                                                                   
function tree_get_subfolders($ntype, $nid, $t_type = "", $rowval = "", $itype = "",$field="",$skipfields="",$displayTypes=null) {
global $LEAF, $PERMSQL, $T_TYPE, $DEBUG, $DTYPE_CACHE, $MDTYPE_CACHE, $T_PTREE, $INSTANT_CACHE;

//                                             

if ($DEBUG["echo"] && $DEBUG["tree"]) {
echo "<br>----- get_subfolders($ntype,$nid):<br>\n";
}

if (!$t_type) $t_type = $T_TYPE;

//                       
 if (!$itype) $itype = tree_get_typeinstance($ntype, $nid, $t_type, $rowval, $field, $skipfields);

$itype_key = md5(serialize($itype));
if (isset($INSTANT_CACHE["subfolder"][$ntype][$nid][$itype_key])) {
if ($DEBUG["echo"] && $DEBUG["tree"]) echo "cached<br>\n";
return $INSTANT_CACHE["subfolder"][$ntype][$nid][$itype_key];
}

//                                                                                             
 if ($itype["sqlleaf"]) {

$sqlleaf = $itype["sqlleaf"];
$rs = query($sqlleaf);//            

if (is_array($rs["arr"])) {
while (list($key,$val) = each($rs["arr"])) {
$LEAF[$val["t_type"]][$val["id"]] = true;
}
}
}

$result = array();

//                    
 $rs = array();

//          
 if (is_array($MDTYPE_CACHE) && $MDTYPE_CACHE[$nid][$ntype]) {
//                                                     
 $res = $MDTYPE_CACHE[$nid][$ntype];
if ($res) {
while (list($key,$val) = each($res)) {
if ($val["bind_id"] && $val["bind_type"]) {
$v["type"] = $val["bind_type"];
$v["id"] = $val["bind_id"];
$v["name"] = $val["name"];
$result[] = $v;
} else {
$v = array();
$v["type"] = $T_PTREE;
$v["id"] = $val["id"];
$v["name"] = $val["name"];
$result[] = $v;
}
}
}
}

//                                                   
 if ($LEAF[$ntype][$nid] || (!$itype["sql"] && !$itype["fkt"])) {
$INSTANT_CACHE["subfolder"][$ntype][$nid][$itype_key] = $result;
return $result;
}

//        
 if ($sql = $itype["sql"]) {
$res = query($sql);//            
 if ($rs) {
while (list($key,$val) = each($res["arr"])) {
$rs[] = $val;
} 
} else $rs = $res["arr"];
}
//         
 if ($fkt = $itype["fkt"]) {
eval("\$rs1 = $fkt;");
if ($rs) {
while (list($key,$val) = each($rs1)) {
$rs[] = $val;
}
} else $rs = $rs1;
}

//                          
 if (is_array($rs)) {
reset($rs);

while (list($key,$val) = each($rs)) {

$nshow = true;

//                                                       
 //                                                 
 //                                
 //                                                
 //   
 if (!isset($t_type[$val[$itype["ntype"]]])) { 

if ($DEBUG["echo"] && $DEBUG["tree"]) echo "skipping type (".$val[$itype["ntype"]].")<br>\n ";
continue;
}
//                                                                                      
 if ($displayTypes && ! in_array($val[$itype["ntype"]], $displayTypes)) {
if ($DEBUG["echo"] && $DEBUG["tree"]) echo "skipping type (".$val[$itype["ntype"]]."), since not in displayTypes<br/>\n";
continue;
}
if ($nshow && $val) {
$val["nmother"] = $nid;
$val["nmother_type"] = $ntype;

$v = array();
$v["type"] = $val[$itype["ntype"]];
$v["id"] = $val[$itype["nid"]];
$v["name"] = $val[$itype["nname"]];
$v["val"] = $val;
$result[] = $v;
}
}
}

$INSTANT_CACHE["subfolder"][$ntype][$nid][$itype_key] = $result;

return $result;
}

//                                               
//                                                                          
//                                                               
function tree_get_parent($ntype, $nid, $t_type = "", $rowval = "", $field = "", $skipfields = "") {

$itype = tree_get_typeinstance($ntype, $nid, $t_type, $rowval, $field, $skipfields);

$rs = array();
$parent = false;

//        
 if ($sql = $itype["parent"]) {
$res = query($sql);//            
 if ($rs) {
while (list($key,$val) = each($res["arr"])) {
$rs[] = $val;
} 
} else $rs = $res["arr"];
}
//         
 if ($fkt = $itype["parentfkt"]) {
eval("\$rs1 = $fkt;");
if ($rs) {
while (list($key,$val) = each($rs1)) {
$rs[] = $val;
}
} else $rs = $rs1;
}

//                          
 if (is_array($rs) && count($rs) > 0 ) {
reset($rs);
list($key,$val) = each($rs);

$parent = array();
$parent["type"] = $val[$itype["ntype"]];
$parent["id"] = $val[$itype["nid"]];
$parent["name"] = $val[$itype["nname"]];
$parent["val"] = $val;
}

return $parent;
}

//                                                                           
function tree_is_checked($ntype, $nid, $t_type = "", $rowval = "", $itype="") {
global $T_TYPE;

if (!$t_type) $t_type = $T_TYPE;

if ($var = $t_type[$ntype]["chkvar"]) {
global $$var;
if (is_array($$var)) {
return (${$var}[$nid])?true:false;
}
}
}

//                                                        
function tree_get_types($type,$id,$maxdepth=0,$t_type="", $rowval = "") {
global $PRT_TREE_VISITED;
$PRT_TREE_VISITED = array();

$list = array();
$list[$type] = true;

prt_walk_types($type,$id,$maxdepth,$t_type,$rowval,$list);

reset($list);
return $list;
}

//                                                                   
function tree_get_paths($type,$id,$to_type,$to_id,$maxdepth=0,$t_type="", $rowval = "", $displayTypes = null) {
global $PRT_TREE_VISITED;
$PRT_TREE_VISITED = array();

$list = array();

$rs = prt_walk_paths($type,$id,$to_type,$to_id,$maxdepth,$t_type,$rowval,$list,$displayTypes);

reset($list);

return ($rs)?$list:false;
}

//                                       
function tree_get_objects($type,$id,$maxdepth=0,$t_type="") {
global $PRT_TREE_VISITED, $DEBUG;
$PRT_TREE_VISITED = array();

if ($DEBUG["echo"] && $DEBUG["tree"]) echo "--- tree_get_objects($type,$id) ---<br>\n";

$list = array();

$v  = array();
$v["type"] = $type;
$v["id"] = $id;
$list[] = $v;

prt_walk_objects($type,$id,$maxdepth,$t_type,$rowval,$list);

reset($list);
return $list;
}

function tree_get_parents($type,$id,$maxdepth=0,$t_type="",$field="",$skipprops="",$root_type,$root_id) {
global $PRT_TREE_VISITED, $DEBUG;

$list = array();

if ( $root_type && $root_type == $type && $root_id == $id ) {
return array();
}

while ($type && $id) {
$parent = tree_get_parent($type,$id,$t_type,"",$field,$skipprops);
if ($parent == false) {
return $root_type ? false : $list;
}

$list[] = $parent;

$type = $parent["type"];
$id = $parent["id"];

if ( $root_type && $root_type == $type && $root_id == $id ) {
return $list;
}

if ($maxdepth > 0 ) {
if (--$maxdepth == 0) {
return $root_type ? false : $list;
}
}
}

return $root_type ? false : $list;
}

//                                                                
$PRT_TREE_VISITED = array();

//                                     
function prt_walk_types($type,$id,$depth,$t_type,$rowval,&$list) {
global $PRT_TREE_VISITED;
if ($PRT_TREE_VISITED[$type][$id]) return false; else $PRT_TREE_VISITED[$type][$id] = true;

$sub = tree_get_subfolders($type,$id,$t_type,$rowval);

if (is_array($sub)) {
while (list($key,$val) = each($sub)) {
$type = (int) $val["type"];
$list[$type] = true;
if ($depth <= 0 || $depth > 1) prt_walk_types($val["type"],$val["id"],$depth-1,$t_type,$val["val"],$list);
}
}
}

//                                     
function prt_walk_paths($type,$id,$to_type,$to_id,$depth,$t_type,$rowval,&$list,$displayTypes) {
global $PRT_TREE_VISITED;
if ($PRT_TREE_VISITED[$type][$id]) return false; else $PRT_TREE_VISITED[$type][$id] = true;

//                                                    
 if ($type == $to_type && $id == $to_id) {
$list = array();
return true;
}

//                    
 $sub = tree_get_subfolders($type,$id,$t_type,$rowval,"","","",$displayTypes);

if (is_array($sub) && ($depth <= 0 || $depth > 1)) {
//                       
 $lst = array();
while (list($key,$val) = each($sub)) {
$lst[abs($val["type"] - $to_type)][] = $val;
}
ksort($lst);
reset($lst);
//                    
 while (list($k,$sub) = each($lst)) {
while (list($k,$val) = each($sub)) {
$type = $val["type"];
$id = $val["id"];
if (prt_walk_paths($type,$id,$to_type,$to_id,--$depth,$t_type,$val["val"],$list,$displayTypes)) {
//                                                            
 $rs = array("id"=>$id,"type"=>$type);
$list[] = $rs;
return true;
}
}
}

} else if (is_array($sub)) {
//                            
 while (list($key,$val) = each($sub)) {
$type = (int) $val["type"];
$id = $val["id"];
if ($type == $to_type && $id == $to_id) {
$rs = array("id"=>$id,"type"=>$type);
$list = array();
$list[] = $rs;
return true;
}
}
}

return false;
}

//                                       
function prt_walk_objects($type,$id,$depth,$t_type,$rowval,&$list) {
global $PRT_TREE_VISITED;
if ($PRT_TREE_VISITED[$type][$id]) return false; else $PRT_TREE_VISITED[$type][$id] = true;

$sub = tree_get_subfolders($type,$id,$t_type,$rowval);

//                                              
 if (is_array($sub)) {
while (list($key,$val) = each($sub)) {
$list[] = $val;
if ($depth <= 0 || $depth > 1) prt_walk_objects($val["type"],$val["id"],$depth-1,$t_type,$val["val"],$list);
}
}
}

?>
